// addmzhdr, add mz header to a 16 bit .bin file to create an mz .exe file
// Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include"stdhdr.h"

#define HDR_SZ 512
image_dos_hdr_t *xh;
us initss=0,initsp=0,initip=0,init_min_mem=0,init_max_mem=0xffff;
us reloc_count=0,reloc_start=0x1e;

void processfile(char*,char*);
  char *mem;

int main(int argc,char **argv) {
  us ix;

  GETOPT
  GETOPTVALUE('r',reloc_count,xstrtol);
  GETOPTVALUE('R',reloc_start,xstrtol);
  GETOPTVALUE('S',initss,xstrtol);
   GETOPTVALUE('s',initsp,xstrtol);
  GETOPTVALUE('i',initip,xstrtol);
  GETOPTVALUE('m',init_min_mem,xstrtol);
  GETOPTVALUE('M',init_max_mem,xstrtol);
  GETOPTEND("-r reloc count -R reloc start-S init ss, -s init sp, -i init ip -m min mem tokeep, -M max mem");

  if(argc<2)
  term(1,"need file to process");

    processfile(argv[1],(argc>2)?argv[2]:NULL);
  return 0;
}

void processfile(char *fn,char *ofn) {
  FILE *fh;
  ul sz=getfsize(fn);
  ul msz=sz+HDR_SZ;

  if(!sz)
    term(1,"you are trying to process a zero length file %s",fn);

  fh=xfopen(fn,"rb");

  mem=xmalloc(msz);

  if(!fread(mem+HDR_SZ,sz,1,fh))
    term(1,"errro rading file %s",fn);
  fclose(fh);

  if(!memcmp(mem+HDR_SZ,"MZ",2)) {
    msz=sz;
  mem+=HDR_SZ;
  xh=(image_dos_hdr_t*)mem;
  sz-=0x200;
    goto just_update;
  }

  memset(mem,0,HDR_SZ);
  xh=(image_dos_hdr_t*)mem;
  memcpy(&xh->e_magic,"MZ",2);
 xh->e_cparhdr=HDR_SZ/0x10;      /* Size of header, in paragraphs */
 xh->            e_ovno;       /* Overlay number */
  xh->e_res[0]=1; // reserved

just_update:
	xh->e_crlc=reloc_count;
 xh->e_lfarlc=reloc_start;    /* Offset of first relo item */
 xh->e_cblp=sz%512;        /* Image size mod 512 (valid bytes in last page) */
 xh->e_cp=sz/512;         /* # 512-byte e_cp in image */
 if(xh->e_cblp)
 xh->e_cp++;
  xh->e_cp++;
 xh->e_minalloc=init_min_mem; /* Min required memory */
 xh->e_maxalloc=init_max_mem;       /* Max required memory */
   xh->e_ss=initss;
   xh->e_sp=initsp;
   xh->e_ip=initip;
  if(!ofn)
  ofn=xstrdup(fn);
  fh=xfopen(ofn,"wb");
  if(!fwrite(mem,msz,1,fh))
    term(1,"error writing to %s ",fn);

  free(mem);
  fclose(fh);
}
