// addmzhdr, add mz header to a 16 bit .bin file to create an mz .exe file
// Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#ifndef __asmlib_h
#define __asmlib_h

#ifndef _d_code16gcc

#include  "stdtypes.h"

#if defined(WIN32)||defined(__DJGPP__)
#define _d_prefix "_"
#else
#define _d_prefix
#endif
#define _d_fn(a,...) stdcall a __VA_ARGS__ asm(_d_prefix #a "32")
#define pascal_call(foo,...) stdcall f_##foo(__VA_ARGS__) asm(#foo "32")
#if (defined(__DJGPP__)||defined(_d_pm))
void pascal_call(serial_puts,int,void*);
void pascal_call(serial_putc,int,int);
short pascal_call(serial_getch,int,int);
void _d_fn(set_rts,(us,uc));
int _d_fn(is_serial_data,(us));
short _d_fn(serial_mputc,(char,us,ul));
ul _d_fn(serial_get_config,(us));
us _d_fn(serial_get_ctl_regs,(us));
us _d_fn(serial_status,(us));
void _d_fn(serial_config,(us,us));
void _d_fn(serial_mcr,(us,uc));
void _d_fn(serial_putz,(us,char*));
#endif

void _d_fn(udelayx,(ul,ul));
void _d_fn(udelay2,(ul));

#ifndef WIN32
ul _d_fn(inet_addr,(char*));
#endif
void *_d_fn(nmalloc,(ul));
int _d_fn(nfree,(void*));
ul _d_fn(linelen,(char*));
void * _d_fn(row_col2ptr,(char*,ul,ul));
char *_d_fn(linestart,(char*,char*));
char *_d_fn(delete_line,(char*,char*));
ul _d_fn(ved_strpcrlf,(char*,ul));
char * _d_fn(cnv_w2ascii,(char*,us*));
us * _d_fn(cnv_ascii2w,(us*,char*));
void  _d_fn(cnv_ascii2w_n,(us*,char*,ul));
void  _d_fn(cnv_w2ascii_n,(char*,us*,ul));
int _d_fn(divq,(quad,quad));
ul _d_fn(divqu,(uq,uq));
ul _d_fn(bitmask,(ul));
ul _d_fn(get_bit_array,(void*,ul,ul));
ul _d_fn(put_bit_array,(void*,ul,ul,ul));
uc _d_fn(bcd2char,(uc));
us _d_fn(bcd2word,(us));
uc _d_fn(get_days_in_month,(us,uc));
ul _d_fn(bcd2days,(ul));
ul _d_fn(fat_fill_slots,(char *,void*));
void _d_fn(fat_fill_slot,(uc,uc,char*,void*));
ul _d_fn(align_to,(ul,ul));
ul _d_fn(do_align,(ul,ul));
void * _d_fn(strrchrc,(void*,int,int));
ul  _d_fn(fat_get_type,(void*));
ul  _d_fn(fat_get_end,(void*));
ul  _d_fn(fat_cl2sec,(void*,ul));
void _d_fn(bslash2slash,(void*));
void _d_fn(slash2bslash,(void*));
void _d_fn(get_idtr,(void*));
void _d_fn(get_gdtr,(void*));
us _d_fn(parport_high_port,(us));
uc _d_fn(get_ansi,(void*,void*,void**));
int _d_fn(divisor2baud,(us));
short _d_fn(baud2divisor,(ul));
int _d_fn(isspacenl,(int));
void * _d_fn(short_name2dirent,(void*,void*));
ul  _d_fn(days_in_year,(ul));
void * _d_fn(unix2bcd,(ul,void*));
us  _d_fn(unix2fatdate,(ul));
us  _d_fn(unix2fattime,(ul));
ul _d_fn(addcrlf_insitu,(void*,ul));

#if defined(__DJGPP__)||defined(_d_pm)
uc _d_fn(inb,(us));
us _d_fn(inw,(us));
us _d_fn(inw_b,(us));
ul _d_fn(inl,(us));
void _d_fn(outb,(uc,us));
void _d_fn(outw,(us,us));
void _d_fn(outw_b,(us,us));
void _d_fn(outl,(ul,us));
ul _d_fn(insb,(us,void*,ul));
ul _d_fn(insw,(us,void*,ul));
ul _d_fn(insl,(us,void*,ul));
ul _d_fn(outsb,(us,void*,ul));
ul _d_fn(outsw,(us,void*,ul));
ul _d_fn(outsl,(us,void*,ul));
#endif

#ifndef _d_cant_do_ports
void _d_fn(ctr0_ticks,(ul));
us _d_fn(parport_putc,(uc,us));
us _d_fn(parport_puts,(us,char*));
us _d_fn(parport_set_mode,(us,uc));
us _d_fn(parport_set_bi_direc,(us,uc));
uc _d_fn(getcmos,(us));
int _d_fn(is_cts,(us));
#ifndef __DJGPP__
void _d_fn(sound,(ul));
#endif
void _d_fn(playnote_ms,(ul,ul));
void _d_fn(dos_playnote_ms,(ul,ul));
void _d_fn(nosound,(void));
uc  _d_fn(pcicfg_read_byte,(us,uc));
us  _d_fn(pcicfg_read_word,(us,uc));
ul  _d_fn(pcicfg_read_dword,(us,uc));
void  _d_fn(pcicfg_write_byte,(us,uc,uc));
void  _d_fn(pcicfg_write_word,(us,uc,us));
void  _d_fn(pcicfg_write_dword,(us,uc,ul));
ul _d_fn(pcicfg_conf1_detect,(void));
ul _d_fn(pcicfg_conf2_detect,(void));
#endif

#if defined(_d_pm)||defined(__DJGPP__)
uc _d_fn(set_com_parms,(us,ul,uc,uc));
ul _d_fn(xget_drive_parms,(us,void*));
ul _d_fn(getfsize,(void*));
#endif
#if defined(_d_pm)
ul _d_fn(lseek,(int,ul,uc));
#endif

#undef _d_prefix
#undef _d_fn

#endif
#endif
