// addmzhdr, add mz header to a 16 bit .bin file to create an mz .exe file
// Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#ifndef __linux_syscalls_h
#define __linux_syscalls_h
#include "stddefs.h"
#include <asm/unistd.h>
#include "stdtypes.h"
static inline  sys_open(char *fn,int flags) {
  asm("mov %0,%%ebx"::"m"(fn));
  asm("mov %0,%%ecx"::"m"(flags));
  asm("mov %0,%%eax"::"n"(__NR_open));
 asm("int $0x80");
}

static inline  sys_read(int fd,void *buf,int l) {
  asm("mov %0,%%ebx"::"m"(fd));
  asm("mov %0,%%ecx"::"m"(buf));
  asm("mov %0,%%edx"::"m"(l));
  asm("mov %0,%%eax"::"n"(__NR_read));
 asm("int $0x80");
}

#ifdef _I386_PTRACE_H
#define execve(...) sys_execve(__VA_ARGS__)
static inline  sys_execve(struct pt_regs regs) {
  asm("mov %0,%%ebx"::"m"(regs));
  asm("mov %0,%%eax"::"n"(__NR_execve));
 asm("int $0x80");
}

#endif

static inline sys_gettimeofday(void *tv,void *tz) {
  asm("mov %0,%%ebx"::"m"(tv));
  asm("mov %0,%%ecx"::"m"(tz));
  asm("mov %0,%%eax"::"n"(__NR_gettimeofday));
 asm("int $0x80");
}

static inline  sys_exit(int r) {
  asm("mov %0,%%ebx"::"m"(r));
  asm("mov %0,%%eax"::"n"(__NR_exit));
 asm("int $0x80");
}

#define sync(...) sys_sync(__VA_ARGS__)
static inline  sys_sync() {
  asm("mov %0,%%eax"::"n"(__NR_sync));
 asm("int $0x80");
}

static inline sys_select(int fd,void *ecx,void *edx,
void *esi,void*edi) {
  setreg(ebx,"m"(fd));
  setreg(ecx,"m"(ecx));
  setreg(edx,"m"(edx));
  setreg(esi,"m"(esi));
  setreg(edi,"m"(edi));
  setreg(eax,"n"(__NR__newselect));
 asm("int $0x80");
}

#define dup2(...) sys_dup2(__VA_ARGS__)
static inline  sys_dup2(int fd1,int fd2) {
  asm("mov %0,%%ebx"::"m"(fd1));
  asm("mov %0,%%ecx"::"m"(fd2));
  asm("mov %0,%%eax"::"n"(__NR_dup2));
 asm("int $0x80");
}

#define iopl(...) sys_iopl(__VA_ARGS__)
static inline  sys_iopl(int r) {
  asm("mov %0,%%ebx"::"m"(r));
  asm("mov %0,%%eax"::"n"(__NR_iopl));
 asm("int $0x80");
}

extern int __speech_fd,__initctl_fd;

#endif
